/*	uiclient.h - Created by Giampiero Caprino

This file is part of Train Director 3

Train Director is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; using exclusively version 2.
It is expressly forbidden the use of higher versions of the GNU
General Public License.

Train Director is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Train Director; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
*/

#ifndef _UICLIENT_H
#define _UICLIENT_H

#include "TConfig.h"

class Traindir;
class Track;

class MainFrame;

class UIClient {
public:
        UIClient(Traindir *app) { }
        virtual ~UIClient() { };

        virtual void Show(void) { };
        virtual void LoadState(Char *section, TConfig& state) { };
        virtual void SaveState(Char *section, TConfig& state) { };

        virtual MainFrame *GetFrame() { return 0; };
        virtual void ShowHtml(const Char *pageName, const wxString& content) { };
        virtual void ShowTools(bool showHide) { };
        virtual void ShowItinerary(bool showHide) { };
        virtual void ShowGraph(void) { };
        virtual void BringPageToFront(const Char *label) { };

        // dialogs

        virtual int AskQuestion(const Char *msg) = 0;
        virtual void ShowErrorBox(const Char *error_msg) { };
        virtual void ShowTrackProperties(Track *trk) { };
};


#endif // _UICLIENT_H

